struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

varying vec3 aPos;
varying vec3 vColor;
varying vec4 vPos;
varying vec3 newNorm;

varying vec2 vTexCoord;

uniform int uNasty;
uniform vec3 uLCol;

uniform sampler2D uTexUnit;

uniform mat4 uModelMatrix;

uniform mat4 uViewInv;
uniform mat3 uModInvTransp;

uniform Material uMat;

void main() {
  vec3 Refl;
  vec3 Spec, Diffuse;
  vec4 vPosition = vPos;
  vec4 light;
  vec3 tempNorm = normalize(newNorm);
  vec3 viewDir;
  vec4 texColor0 = vec4(vColor.x, vColor.y, vColor.z, 1);
  vec4 texColor1 = texture2D(uTexUnit, vTexCoord);
  if (uNasty == 1)
     gl_FragColor = vec4(vColor.r, vColor.g, vColor.b, 1.0);
  else if (uNasty == 0) {
     viewDir = normalize(vec3(uViewInv * vec4(0.0, 0.0, 0.0, 1.0) - vPosition));
     //light = normalize((vec4 (uLPos, 1)) - vPosition);
     light = normalize(vec4(0.0, 1.0, -1.0, 0.0));
     Diffuse = uLCol * max(dot(tempNorm, vec3(light)), 0.0) * uMat.dColor;
     Refl = (-1.0 * (vec3(light))) + (2.0 * (max(dot(vec3(light), tempNorm), 0.0)) * vec3(tempNorm));
     Spec = uLCol * clamp(pow(max(dot(Refl, viewDir), 0.0), uMat.shine), 0.0, 1.0) * uMat.sColor;
     gl_FragColor = vec4(Diffuse + Spec + uMat.aColor * uLCol, 1.0);
  }
  else if (uNasty == 2)
      gl_FragColor = vec4(texColor1[0], texColor1[1], texColor1[2], 1);
     //gl_FragColor = vec4(vTexCoord.s, vTexCoord.t, 0, 1);
}
