struct Material {
  vec3 aColor;
  vec3 dColor;
  vec3 sColor;
  float shine;
};

attribute vec3 aPosition;
attribute vec3 aColor;
attribute vec3 aNormal;

attribute vec2 aTexCoord;

varying vec3 aPos;
varying vec3 vColor;
varying vec4 vPos;
varying vec3 newNorm;

varying vec2 vTexCoord;

uniform mat4 uProjMatrix;
uniform mat4 uViewMatrix;
uniform mat4 uModelMatrix;

uniform int uNasty;
uniform vec3 uLCol;

uniform mat4 uViewInv;
uniform mat3 uModInvTransp;

uniform Material uMat;

void main() {
  vec4 vPosition;
  vec4 light;
  vec3 tempNorm;
  vec3 Refl;
  vec3 Spec, Diffuse;
  vec3 viewDir;

  aPos = aPosition;
  
  newNorm = tempNorm = normalize(uModInvTransp * aNormal);

  /* First model transforms */
  vPosition = uModelMatrix * vec4(aPosition.x, aPosition.y, aPosition.z, 1);
  vPos = vPosition = uViewMatrix * vPosition;
  gl_Position = uProjMatrix*vPosition;
  gl_FrontColor = vec4(aColor.r, aColor.g, aColor.b, 1.0);
  
  if (uNasty == 0) {
     vColor = vec3(tempNorm);
  } else if (uNasty == 1) {
     vColor = uLCol;
  }
  vTexCoord = aTexCoord;
}
